#include "compito.h"

// --- FUNZIONI DI UTILITA' -----------------------

void VettoreSparso::distruggi(){
	elem *p=p0, *q;
	while (p){
		q = p->pun;
		delete p;
		p = q;
	}	
}

// --- PRIMA PARTE ------------------------------

VettoreSparso::VettoreSparso(int d){
	if ( d < 0 )
		d = 10; // alternativamente, mettere al posto di 'd=10;' l'istruzione 'exit(1)';
	dim = d; 
	p0 = NULL;
};

void VettoreSparso::set(int v, int i){
	// controllo degli ingressi
	if ( (v == 0) || (i < 0) || (i >= dim) )
		return;
		
  elem *p, *q;
	for ( p = p0; p != NULL && p->ind <= i; p=p->pun)
		q = p;
	if ( p == p0 ){ // ins. in testa
		p0 = new elem;
		p0->ind = i;
		p0->val = v;
		p0->pun = p;
	}else{
		if (q ->ind == i){    // modifico valore in entrata esistente
			q->val = v;			
		}else{			
			elem *r = new elem;
			r->ind = i;
			r->val = v;
			r->pun = p;
			q->pun = r;
		}
	}
}

ostream & operator <<(ostream &os, const VettoreSparso &s){
	elem *p = s.p0, *q;
	os<<'['<<s.dim<<"]{";
	while (p != NULL){
		os<<'('<<p->val<<','<<p->ind<<')';
		q = p;
		p = p->pun;
	}
	os<<'}';
	return os;
}


// --- SECONDA PARTE ------------------------------
void VettoreSparso::visualizzaComeDenso()const{
	elem *p=p0;
	cout<<"< ";
	for (int j=0; j<dim; j++){
		if (p!= NULL && p->ind == j){
			cout<<p->val<<' ';
			p = p->pun;		
		}else
			cout<<"0 ";
    }
	cout<<'>';
}

void VettoreSparso::reset(int i){
	if ( i<0 || i>=dim)
		return;
    
	elem *p, *q;	
	for( p = p0; (p != NULL && p->ind < i); p=p->pun)
		q = p;
	
	if ( p != NULL && p->ind == i ){
		if ( p != p0){ // eliminazione in mezzo o in coda
			q->pun = p->pun;
			delete p;
		}else{ // eliminazione in testa
			p0 = p->pun;
			delete p;			
		}		 
	}
}

VettoreSparso& VettoreSparso::operator *=(int k){
	if (k==0){
		distruggi();
    p0 = NULL;
  }else{
		for (elem *p=p0; p!=NULL; p=p->pun)
			p->val*=k;
  }
	return *this;
}

// TERZA PARTE
// funzione di utilita'
void VettoreSparso::copia(const VettoreSparso &s){
  p0 = NULL;
  dim = s.dim;
  elem *p = s.p0, *q = NULL, *r;
  while ( p != NULL){
    r = new elem;
    r->val = p->val;
    r->ind = p->ind;
    r->pun = NULL;
    if ( q == NULL )
      q = p0 = r;
    else{
      q->pun = r;
      q = q->pun;
    }
    p = p->pun;
  }
}
VettoreSparso::VettoreSparso(const VettoreSparso &s){
  copia(s);
}


VettoreSparso& VettoreSparso::operator=(const VettoreSparso &s){
  if (this != &s){
    distruggi();
    copia(s);
  }
  return *this;
}

int VettoreSparso::get(int ind)const{
    if ( (ind < 0 ) || ( ind >= dim ) )
      exit(1);
    elem *p;
    for( p = p0; p != NULL && p->ind < ind; p = p->pun);
    if ( p != NULL && p->ind == ind)
       return p->val;
    else
      return 0;
}
